function tipoTituloReceber() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');
	const self = this;
	const tipoReceberGridId = '150631336237604912933575';

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		self.clickByPath(['Parametrização', 'Financeiro', 'Títulos a Receber', 'Tipo de Títulos a Receber']);
		geral.esperarLoading();
		geral.clickAplicarFiltro();
	};

	// Override funçao Zeedhi, pois não funciona para 'Títulos a Receber'
	this.clickByPath = function (fullPath) {
		let prefix = '.zh-main-menu>.menu-group>.menu-group-items>';
		let child;
		for (const index in fullPath) {
			if (fullPath.hasOwnProperty(index)) {
				if (fullPath[index] == 'Títulos a Receber') {
					child = element.all(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index])).get(1);
				} else {
					child = element(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index]));
				}
				child = child.element(by.xpath('..')).element(by.xpath('..'));
				protractorHelper.click(child);
				prefix = '.sub-menu>';
				browser.sleep(500);
			}
		}
	};

	this.clickTitulo = (codigo) => {
		geral.filterIt(codigo);
		geral.clickGrid('CDTPCTRECEB', codigo, tipoReceberGridId);
	};

	this.adicionaTitulo = (codigo, descricao, contaContabil, classificaoFinacneira, descricaoDocumento, historicoIntegracao) => {
		geral.clickAdicionar();
		geral.clickAndFillField('CDTPCTRECEB', codigo);
		geral.clickAndFillField('DSTPCTRECEB', descricao);
		// Seleciona conta Contábil
		geral.searchAndClickGridField('CDCONTCTBL', contaContabil, 'NMCONTCTBL');
		// Seleciona Classificação Financeira
		geral.searchAndClickGridField('DSCLASSFINA', classificaoFinacneira, 'DSCLASSFINA');
		geral.clickAndFillField('DSDEFACTREC', descricaoDocumento);
		// Utiliza em Lançamento Manual na Tela de Contas a Receber/Recebidas
		geral.searchAndClickGridField('DSHISTPADR', historicoIntegracao, 'CDHISTPADR');
		geral.selectNative('IDUTLANCCREC', 'Sim');
		// Tipo de Conta
		geral.selectNative('IDTPCTRECEBER', 'Normal');
		// Contabiliza Lançamento
		geral.selectNative('IDCTBLCTREC', 'Sim');
		// Contabiliza por Conta na Baixa
		geral.selectNative('IDCTBTPCNTBREC', 'Sim');
	};

	this.edita = (descricao, contaContabil, classificaoFinacneira, descricaoDocumento, historicoIntegracao,
		lancamentoManual) => {
		geral.fillField('DSTPCTRECEB', descricao);
		// Seleciona conta Contábil
		protractorHelper.click(element(by.css('#CDCONTCTBL .zh-icon-close-x')), 3000);
		geral.searchAndClickGridField('CDCONTCTBL', contaContabil, 'NMCONTCTBL');
		// Seleciona Classificação Financeira
		protractorHelper.click(element(by.css('#DSCLASSFINA .zh-icon-close-x')), 3000);
		geral.searchAndClickGridField('DSCLASSFINA', classificaoFinacneira, 'DSCLASSFINA');
		geral.fillField('DSDEFACTREC', descricaoDocumento);
		// Utiliza em Lançamento Manual na Tela de Contas a Receber/Recebidas
		protractorHelper.click(element(by.css('#DSHISTPADR .zh-icon-close-x')), 3000);
		geral.searchAndClickGridField('DSHISTPADR', historicoIntegracao, 'CDHISTPADR');
		geral.selectNative('IDUTLANCCREC', lancamentoManual);
	};

	this.adicionaEmpresa = (empresa) => {
		geral.trocarAba('Empresa');
		geral.clickAdicionar();
		geral.selectMultiple('NMEMPRESA', 'NMEMPRESA', empresa);
	};

	this.excluiEmpresa = (nomeEmpresa) => {
		geral.trocarAba('Empresa');
		geral.clickGrid('NMEMPRESA', nomeEmpresa, '15063133621083611323224');
		geral.clickExcluir();
		geral.clickSim();
	};

	this.exclui = () => {
		geral.clickExcluir();
		geral.clickSim();
	};
}

module.exports = new tipoTituloReceber();
